From 169bb47773b665105b30573499f2ce6c4323820f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 02 2020 05:07:17 +0000
Subject: [PATCH 1211/2232] Clean up control flow of write::gen


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 7753ebf..f5ef807 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -22,11 +22,7 @@ pub(super) fn gen(apis: &[Api], types: &Types, opt: &Opt, header: bool) -> Vec<u
     write_namespace_forward_declarations(out, &apis_by_namespace);
     write_data_structures(out, apis);
     write_functions(out, apis);
-
-    if !header {
-        out.next_section();
-        write_generic_instantiations(out);
-    }
+    write_generic_instantiations(out);
 
     builtin::write(out);
     include::write(out);
@@ -957,6 +953,11 @@ fn to_mangled(ty: &Type, types: &Types) -> Symbol {
 }
 
 fn write_generic_instantiations(out: &mut OutFile) {
+    if out.header {
+        return;
+    }
+
+    out.next_section();
     out.set_namespace(Default::default());
     out.begin_block(Block::ExternC);
     for ty in out.types {

